grammar Gram ;

parser parse :: SL_S { Gram ; }

function main 
IOVal<Integer> ::= largs::[String] io_in::IO
{

  local attribute contents :: IOVal<String>;
  contents = readFile(head(largs), io_in);

  local attribute args :: String;
  args = contents.iovalue;

  local attribute result :: ParseResult<SL_S>;
  result = parse(args, "<<args>>");
 
  local attribute r_cst :: SL_S;
  r_cst = result.parseTree;
  
  local attribute print_success :: IO;
  print_success = print( "*** Command line expression : " ++ args                               ++ "\n\n" ++
				                 "*** Show of the original    : " ++ r_cst.pp                           ++ "\n\n" ++
                         "*** Show after get          : " ++ r_cst.get_SL_V.pp                  ++ "\n\n",
                         -- "*** Show after put          : " ++ r_cst.get_SL_S.put_SL_V.pp        ++ "\n\n",
                         io_in );

  local attribute print_failure :: IO;  
  print_failure = print("Encountered a parse error:\n" ++ result.parseErrors ++ "\n", io_in);

  return ioval(if result.parseSuccess then print_success else print_failure, 0);
}

