grammar Gram;

synthesized attribute show :: String;
synthesized attribute pp :: String;
ignore terminal WhiteSpace_t /[\t\n\ ]+/ ;
terminal Int_Lit /[0-9]+/;
terminal String_Lit /[a-zA-Z][a-zA-Z0-9_]*/;


-- These NT used to be the Literal Terminals

synthesized attribute getInfo :: String;
nonterminal Int_NT with getInfo, pp, show;

abstract production int_NT
this::Int_NT ::= v::String
{
  this.show = "int_NT (" ++ v ++ ")";
  this.pp = v;
  this.getInfo = v;
}

