grammar Gram;


nonterminal A with pp, show, link;

-- Links back
annotation link :: Link;
nonterminal Link;

abstract production linkE
this::Link ::= e::E_A
{}

abstract production linkT
this::Link ::= e::T_A
{}

abstract production linkF
this::Link ::= e::F_A
{}

abstract production none
this::Link ::=
{}

------

abstract production p_ADDa
this::A ::= a::A b::A
{
  this.show = "ADDa(" ++ a.show ++ "," ++ b.show ++ ")";
  this.pp = a.pp ++ " " ++ b.pp;
}

abstract production p_SUBa
this::A ::= a::A b::A
{
  this.show = "SUBa(" ++ a.show ++ "," ++ b.show ++ ")";
  this.pp = a.pp ++ " " ++ b.pp;
}

abstract production p_MULa
this::A ::= a::A b::A
{
  this.show = "MULa(" ++ a.show ++ "," ++ b.show ++ ")";
  this.pp = a.pp ++ " " ++ b.pp;
}

abstract production p_VALUEa
this::A ::= a::Int_NT
{
  this.show = "VALUEa(" ++ a.show ++ ")";
  this.pp = a.pp;
}


