grammar Gram;

synthesized attribute get_A :: A;

attribute get_A occurs on E_A;
attribute get_A occurs on T_A;
attribute get_A occurs on F_A;


aspect production p_Add_A
this::E_A ::= a::E_A b::T_A
{
  this.get_A = p_ADDa( a.get_A, b.get_A, link = linkE(this) );
}

aspect production p_Sub_A
this::E_A ::= a::E_A b::T_A
{
  this.get_A = p_SUBa( a.get_A, b.get_A, link = linkE(this) );
}

aspect production p_Et_A
this::E_A ::= a::T_A
{
  this.get_A = a.get_A;
}

aspect production p_Mul_A
this::T_A ::= a::T_A b::F_A
{
  this.get_A = p_MULa( a.get_A, b.get_A, link = linkT(this) );
}

aspect production p_Tf_A
this::T_A ::= a::F_A
{
  this.get_A = a.get_A;
}

aspect production p_Neg_A
this::F_A ::= a::F_A
{
  this.get_A = p_SUBa( p_VALUEa( int_NT("0"), link = none() ), a.get_A, link = linkF(this) );
}

aspect production p_Nest_A
this::F_A ::= a::E_A
{
  this.get_A = a.get_A;
}

aspect production p_Value_A
this::F_A ::= a::Int_NT
{
  this.get_A = p_VALUEa( a, link = linkF(this) );
}


