module Terminals2Silver where

-- This function is just for initialization
-- of terminals or attributes that always appear
-- in both grammars

initialize = let init  = "grammar Gram;"
                 attrs = "synthesized attribute show :: String;\nsynthesized attribute pp :: String;"
                 igns  = "ignore terminal WhiteSpace_t /[\\t\\n\\ ]+/ ;"
				 -- We manually had all the primitives supported in Bidi here,
				 -- to make code simpler. Prims that are declared but unused in
				 -- Silver are note a problem, and its easier than go through
				 -- both gramamrs to check the primitive types they use.
                 prims = "terminal Int_Lit /[0-9]+/;" ++ "\n" ++ "terminal String_Lit /[a-zA-Z][a-zA-Z0-9_]*/;"
             in  unlines [init,attrs,igns,prims]
