grammar Gram;

nonterminal A with pp, show, link;

-- Links Back
annotation link :: Link;
nonterminal Link;

abstract production linkE
this::Link ::= e::E
{}

abstract production linkT
this::Link ::= e::T
{}

abstract production linkF
this::Link ::= e::F
{}

abstract production none
this::Link ::=
{}
------

abstract production p_ADDa
this::A ::= a::A b::A
{
  this.show = "ADDa(" ++ a.show ++ "," ++ b.show ++ ")";
  this.pp = a.pp ++ " " ++ b.pp;
}

abstract production p_SUBa
this::A ::= a::A b::A
{
  this.show = "SUBa(" ++ a.show ++ "," ++ b.show ++ ")";
  this.pp = a.pp ++ " " ++ b.pp;
}

abstract production p_MULa
this::A ::= a::A b::A
{
  this.show = "MULa(" ++ a.show ++ "," ++ b.show ++ ")";
  this.pp = a.pp ++ " " ++ b.pp;
}

abstract production p_VALUEa
this::A ::= a::Int_Lit
{
  this.show = "VALUEa(" ++ a.lexeme ++ ")";
  this.pp = a.lexeme;
}

