grammar Gram ;

parser parse :: E { Gram ; }

function main 
IOVal<Integer> ::= largs::[String] io_in::IO
{

  local attribute args :: String;
  args = implode(" ", largs);

  local attribute result :: ParseResult<E>;
  result = parse(args, "<<args>>");

  local attribute r_cst :: E;
  r_cst = result.parseTree;

  local attribute print_success :: IO;
  print_success = print( "Command line expression        : " ++ args        ++ "\n" ++
				         "Show of the original Concrete  : " ++ r_cst.show  ++ "\n" ++
						 "Show of the Abstract, after get: " ++ r_cst.get_A.show  ++ "\n" ++
						 "Show of the Concrete, after put: " ++ r_cst.get_A.put_E.show ++ "\n",
			           io_in );

  local attribute print_failure :: IO;  
  print_failure = print("Encountered a parse error:\n" ++ result.parseErrors ++ "\n", io_in);

  return ioval(if result.parseSuccess then print_success else print_failure, 0);
}

