grammar Gram ;

parser parse :: SL { Gram ; }

function main 
IOVal<Integer> ::= largs::[String] io_in::IO
{
 
  local attribute args :: String;
  args = implode(" ", largs);

  local attribute result :: ParseResult<SL>;
  result = parse(args, "<<args>>");
 
  local attribute r_cst :: SL;
  r_cst = result.parseTree;
  
  local attribute print_success :: IO;
  print_success = print( "Command line expression : " ++ args                   ++ "\n" ++
				         "Show of the original    : " ++ r_cst.show             ++ "\n" ++
						 "Show after transform    : " ++ r_cst.transformSL.show ++ "\n" ,
						 io_in );

  local attribute print_failure :: IO;  
  print_failure = print("Encountered a parse error:\n" ++ result.parseErrors ++ "\n", io_in);

  return ioval(if result.parseSuccess then print_success else print_failure, 0);
}

